﻿Type=Class
Version=3.8
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Dim bodyEnemy As lgBox2DBody
	Dim EnemySprite As lgSprite
	Dim UD As imageType
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(vTexture As lgSprite, vWidth As Float, vHeight As Float, vPosX As Int, vPosY As Int, vbodyType As String, vReset As Boolean, vAngle As Float, vStartTime As Float)

	UD.mathItem = vbodyType
	
	'Create enemy BodyDef
	Dim enemyDef As lgBox2DBodyDef
	enemyDef.Type = Main.World.BODYTYPE_Dynamic
	enemyDef.position.Set(vPosX, vPosY)
	enemyDef.fixedRotation = False
	
	'enemy Shape
	Dim enemyShape As lgBox2DCircleShape	
	enemyShape.Radius = vWidth
	
	'enemy Fixture
	Dim enemyFixtureDef As lgBox2DFixtureDef
	enemyFixtureDef.shape = enemyShape
	enemyFixtureDef.Density = 0
	enemyFixtureDef.friction = 0
	enemyFixtureDef.restitution = 1
	
	EnemySprite.initializeWithSprite(vTexture)
	EnemySprite.SetSize(vWidth * 2, vHeight * 2)
	EnemySprite.SetOrigin(EnemySprite.Width / 2, EnemySprite.Height / 2)

	
	bodyEnemy = Main.World.CreateBody(enemyDef)
	bodyEnemy.createFixture(enemyFixtureDef)
	
	UD.thisSprite = EnemySprite
	bodyEnemy.UserData = UD
	
	Dim newEnemyItem As enemyType
	newEnemyItem.mathItem = UD.mathItem
	newEnemyItem.startX = vPosX
	newEnemyItem.startY = vPosY
	newEnemyItem.enemyBody = bodyEnemy
	newEnemyItem.StartTime = vStartTime
	
	If vReset = False Then
		globals.allEnemies.Add(newEnemyItem)
	End If	

	Dim vX, vY As Float
	
	vX = Cos(vAngle + 1.57)
	vY = Sin(vAngle + 1.57)
	
	bodyEnemy.setLinearVelocity2(500 * vX, 500 * vY)
	
	enemyShape.Dispose
	
End Sub

