﻿Type=Class
Version=3.8
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Dim bodyMath As lgBox2DBody
	Dim mathSprite As lgSprite
	Dim UD As imageType
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(vTexture As lgSprite, vWidth As Float, vHeight As Float, vPosX As Int, vPosY As Int, vbodyType As String, vReset As Boolean, vAngle As Float, vStartTime As Float)

	UD.mathItem = vbodyType
	
	'Create math BodyDef
	Dim mathDef As lgBox2DBodyDef
	mathDef.Type = Main.World.BODYTYPE_Dynamic
	mathDef.position.Set(vPosX, vPosY)
	mathDef.fixedRotation = False
	
	'math Shape
	Dim mathShape As lgBox2DCircleShape	
	mathShape.Radius = vWidth
	
	'math Fixture
	Dim mathFixtureDef As lgBox2DFixtureDef
	mathFixtureDef.shape = mathShape
	mathFixtureDef.Density = 0
	mathFixtureDef.friction = 0
	mathFixtureDef.restitution = 1
	
	mathSprite.initializeWithSprite(vTexture)
	mathSprite.SetSize(vWidth * 2, vHeight * 2)
	mathSprite.SetOrigin(mathSprite.Width / 2, mathSprite.Height / 2)
	
	bodyMath = Main.World.CreateBody(mathDef)
	bodyMath.createFixture(mathFixtureDef)
	
	UD.thisSprite = mathSprite
	bodyMath.UserData = UD
	
	Dim newMathItem As mathType
	newMathItem.mathItem = UD.mathItem
	newMathItem.startX = vPosX
	newMathItem.startY = vPosY
	newMathItem.mathBody = bodyMath
	newMathItem.StartTime = vStartTime
	
	If vReset = False Then
		globals.allMath.Add(newMathItem)
	End If	

	Dim vX, vY As Float
	
	vX = Cos(vAngle + 1.57)
	vY = Sin(vAngle + 1.57)
	
	Dim rndSpeed As Int
	rndSpeed = Rnd(500,800)
	
	bodyMath.setLinearVelocity2(rndSpeed * vX, rndSpeed * vY)
	
	mathShape.Dispose
	
End Sub

