﻿Type=Class
Version=3.8
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Dim bodyturret As lgBox2DBody
	Dim turretSprite As lgSprite
	Dim rotStart, rotEnd As Float
	Dim rotDirection As Boolean
	
	Dim rotTimer As Timer
	Dim xPos, yPos As Float
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(vTexture As lgSprite, vWidth As Float, vHeight As Float, vPosX As Int, vPosY As Int, vRotStart As Float, vRotEnd As Float, vbodyType As String)

	rotTimer.Initialize("RotTimer", 20)
	
	xPos = vPosX
	yPos = vPosY

	rotStart = vRotStart
	rotEnd = vRotEnd
	rotDirection = True

	Dim UD As imageType
	UD.mathItem = vbodyType

	'Create turret BodyDef
	Dim turretDef As lgBox2DBodyDef
	turretDef.Type = Main.World.BODYTYPE_Kinematic
	turretDef.position.Set(vPosX, vPosY)
	turretDef.angle = rotStart
'	turretDef.fixedRotation = True
	
	'turret Shape
	Dim turretShape As lgBox2DPolygonShape	
	turretShape.SetAsBox(vWidth, vHeight)
	
	'turret Fixture
	Dim turretFixtureDef As lgBox2DFixtureDef
	turretFixtureDef.shape = turretShape
	turretFixtureDef.Density = 2.5
	turretFixtureDef.friction = 0
	turretFixtureDef.restitution = 1
	turretSprite.initializeWithSprite(vTexture)

	turretSprite.SetSize(vWidth * 2, vHeight * 2)
	turretSprite.SetOrigin(turretSprite.Width / 2, turretSprite.Width / 2)
	
	bodyturret = Main.World.CreateBody(turretDef)
	bodyturret.createFixture(turretFixtureDef)
	
	UD.thisSprite = turretSprite
	bodyturret.UserData = UD
	
	Log("vRot: " & rotStart)
	
	Dim newturret As turretType
	newturret.startX = vPosX
	newturret.startY = vPosY
	newturret.initRot = rotStart
	newturret.endRot = rotEnd
	newturret.currRot = rotStart
	newturret.turretBody = bodyturret
	newturret.rotDir = rotDirection

	globals.allEnemyBases.Add(newturret)

	
Log("rSrtart: " & rotStart)
Log("rEnd: " & rotEnd)
	
	turretShape.Dispose
	
'	rotTimer.Enabled = True
	
End Sub

Private Sub rotTimer_TICK

	Dim currRot, newRot As Float
	
	currRot = bodyturret.Angle
'Log("cRot: " & currRot)	
	If rotDirection = True Then 
		newRot = currRot - .01
	Else 
		newRot = currRot + .01
	End If
	
	If newRot > rotStart Then
		rotDirection = True
		newRot = newRot - .1
	End If
	
	If newRot < rotEnd Then
		rotDirection = False
		newRot = newRot + .1
	End If
	
'	bodyturret.setTransform2(bodyturret.Position.x, bodyturret.Position.y, newRot)
	bodyturret.setTransform2(xPos, yPos, newRot)

End Sub


	